Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.8.2 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jivesoftware.openfire
Interface Connection

All Known Implementing Classes:
  ClientSessionConnection, HttpSession.HttpVirtualConnection, NIOConnection, SocketConnection, VirtualConnection

    public interface Connection

Represents a connection on the server.

Author:
  Iain Shigeoka

Nested Class Summary
`static class` | `Connection.ClientAuth` Enumeration that specifies if clients should be authenticated (and how) while negotiating TLS.
`static class` | `Connection.CompressionPolicy` Enumeration of possible compression policies required to interact with the server.
`static class` | `Connection.TLSPolicy` Enumeration of possible TLS policies required to interact with the server.

Method Summary
`void` | `addCompression()` Adds the compression filter to the connection but only filter incoming traffic.
`void` | `close()` Close this session including associated socket connection.
`void` | `deliver(org.xmpp.packet.Packet packet)` Delivers the packet to this connection without checking the recipient.
`void` | `deliverRawText(String text)` Delivers raw text to this connection.
`byte[]` | `getAddress()` Returns the raw IP address of this `InetAddress` object.
`Connection.CompressionPolicy` | `getCompressionPolicy()` Returns whether compression is optional or is disabled.
`String` | `getHostAddress()` Returns the IP address string in textual presentation.
`String` | `getHostName()` Gets the host name for this IP address.
`String` | `getLanguage()` Returns the language code that should be used for this connection (e.g.
`Certificate[]` | `getLocalCertificates()` Returns the local underlying `X509Certificate` chain for the connection.
`int` | `getMajorXMPPVersion()` Returns the major version of XMPP being used by this connection (major_version.minor_version.
`int` | `getMinorXMPPVersion()` Returns the minor version of XMPP being used by this connection (major_version.minor_version.
`PacketDeliverer` | `getPacketDeliverer()` Returns the packet deliverer to use when delivering a packet over the socket fails.
`Certificate[]` | `getPeerCertificates()` Returns the underlying `X509Certificate` for the connection of the peer.
`Connection.TLSPolicy` | `getTlsPolicy()` Returns whether TLS is mandatory, optional or is disabled.
`void` | `init(LocalSession session)` Initializes the connection with it's owning session.
`boolean` | `isClosed()` Returns true if the connection/session is closed.
`boolean` | `isCompressed()` Returns true if the connection is using compression.
`boolean` | `isFlashClient()` Returns true if the connected client is a flash client.
`boolean` | `isSecure()` Returns true if this connection is secure.
`boolean` | `isUsingSelfSignedCertificate()` Returns true if the other peer of this session presented a self-signed certificate.
`void` | `registerCloseListener(ConnectionCloseListener listener, Object handbackMessage)` Registers a listener for close event notification.
`void` | `removeCloseListener(ConnectionCloseListener listener)` Removes a registered close event listener.
`void` | `setCompressionPolicy(Connection.CompressionPolicy compressionPolicy)` Sets whether compression is enabled or is disabled.
`void` | `setFlashClient(boolean flashClient)` Sets whether the connected client is a flash client.
`void` | `setLanaguage(String language)` Sets the language code that should be used for this connection (e.g.
`void` | `setTlsPolicy(Connection.TLSPolicy tlsPolicy)` Sets whether TLS is mandatory, optional or is disabled.
`void` | `setUsingSelfSignedCertificate(boolean isSelfSigned)` Keeps track if the other peer of this session presented a self-signed certificate.
`void` | `setXMPPVersion(int majorVersion, int minorVersion)` Sets the XMPP version information.
`void` | `startCompression()` Start compressing outgoing traffic for this connection.
`void` | `startTLS(boolean clientMode, String remoteServer, Connection.ClientAuth authentication)` Secures the plain connection by negotiating TLS with the other peer.
`void` | `systemShutdown()` Notification message indicating that the server is being shutdown.
`boolean` | `validate()` Verifies that the connection is still live.

Method Detail

### validate

    boolean validate()

  Verifies that the connection is still live. Typically this is done by sending a whitespace character between packets.

  Returns:
    true if the socket remains valid, false otherwise.

### init

    void init(LocalSession session)

  Initializes the connection with it's owning session. Allows the connection class to configure itself with session related information (e.g. stream ID).

  Parameters:
    `session` - the session that owns this connection

### getAddress

    byte[] getAddress()
                      throws UnknownHostException

  Returns the raw IP address of this `InetAddress` object. The result is in network byte order: the highest order byte of the address is in `getAddress()[0]`.

  Returns:
    the raw IP address of this object.
  Throws:
    `UnknownHostException` - if IP address of host could not be determined.

### getHostAddress

    String getHostAddress()
                          throws UnknownHostException

  Returns the IP address string in textual presentation.

  Returns:
    the raw IP address in a string format.
  Throws:
    `UnknownHostException` - if IP address of host could not be determined.

### getHostName

    String getHostName()
                       throws UnknownHostException

  Gets the host name for this IP address.

  If this InetAddress was created with a host name, this host name will be remembered and returned; otherwise, a reverse name lookup will be performed and the result will be returned based on the system configured name lookup service. If a lookup of the name service is required, call `getCanonicalHostName`.

  If there is a security manager, its `checkConnect` method is first called with the hostname and `-1` as its arguments to see if the operation is allowed. If the operation is not allowed, it will return the textual representation of the IP address.

  Returns:
    the host name for this IP address, or if the operation is not allowed by the security check, the textual representation of the IP address.
  Throws:
    `UnknownHostException` - if IP address of host could not be determined.
  See Also:
    `InetAddress.getCanonicalHostName()`, `SecurityManager.checkConnect(java.lang.String, int)`

### getLocalCertificates

    Certificate[] getLocalCertificates()

  Returns the local underlying `X509Certificate` chain for the connection.

  Returns:
    an ordered array of certificates, with the local certificate first followed by any certificate authorities. If no certificates is present for the connection, then `null` is returned.

### getPeerCertificates

    Certificate[] getPeerCertificates()

  Returns the underlying `X509Certificate` for the connection of the peer.

  Returns:
    an ordered array of peer certificates, with the peer's own certificate first followed by any certificate authorities.

### setUsingSelfSignedCertificate

    void setUsingSelfSignedCertificate(boolean isSelfSigned)

  Keeps track if the other peer of this session presented a self-signed certificate. When using self-signed certificate for server-2-server sessions then SASL EXTERNAL will not be used and instead server-dialback will be preferred for vcerifying the identify of the remote server.

  Parameters:
    `isSelfSigned` - true if the other peer presented a self-signed certificate.

### isUsingSelfSignedCertificate

    boolean isUsingSelfSignedCertificate()

  Returns true if the other peer of this session presented a self-signed certificate. When using self-signed certificate for server-2-server sessions then SASL EXTERNAL will not be used and instead server-dialback will be preferred for vcerifying the identify of the remote server.

  Returns:
    true if the other peer of this session presented a self-signed certificate.

### close

    void close()

  Close this session including associated socket connection. The order of events for closing the session is:
  - Set closing flag to prevent redundant shutdowns.
  - Call notifyEvent all listeners that the channel is shutting down.
  - Close the socket.

### systemShutdown

    void systemShutdown()

  Notification message indicating that the server is being shutdown. Implementors should send a stream error whose condition is system-shutdown before closing the connection.

### isClosed

    boolean isClosed()

  Returns true if the connection/session is closed.

  Returns:
    true if the connection is closed.

### isSecure

    boolean isSecure()

  Returns true if this connection is secure.

  Returns:
    true if the connection is secure (e.g. SSL/TLS)

### registerCloseListener

    void registerCloseListener(ConnectionCloseListener listener,
                               Object handbackMessage)

  Registers a listener for close event notification. Registrations after the Session is closed will be immediately notified before the registration call returns (within the context of the registration call). An optional handback object can be associated with the registration if the same listener is registered to listen for multiple connection closures.

  Parameters:
    `listener` - the listener to register for events.
    `handbackMessage` - the object to send in the event notification.

### removeCloseListener

    void removeCloseListener(ConnectionCloseListener listener)

  Removes a registered close event listener. Registered listeners must be able to receive close events up until the time this method returns. (i.e. it is possible to call unregister, receive a close event registration, and then have the unregister call return.)

  Parameters:
    `listener` - the listener to deregister for close events.

### deliver

    void deliver(org.xmpp.packet.Packet packet)
                 throws UnauthorizedException

  Delivers the packet to this connection without checking the recipient. The method essentially calls `socket.send(packet.getWriteBuffer())`.

  Parameters:
    `packet` - the packet to deliver.
  Throws:
    `UnauthorizedException` - if a permission error was detected.

### deliverRawText

    void deliverRawText(String text)

  Delivers raw text to this connection. This is a very low level way for sending XML stanzas to the client. This method should not be used unless you have very good reasons for not using `deliver(org.xmpp.packet.Packet)`.

  This method avoids having to get the writer of this connection and mess directly with the writer. Therefore, this method ensures a correct delivery of the stanza even if other threads were sending data concurrently.

  Parameters:
    `text` - the XML stanzas represented kept in a String.

### isFlashClient

    boolean isFlashClient()

  Returns true if the connected client is a flash client. Flash clients need to receive a special character (i.e. \0) at the end of each xml packet. Flash clients may send the character \0 in incoming packets and may start a connection using another openning tag such as: "flash:client".

  Returns:
    true if the connected client is a flash client.

### setFlashClient

    void setFlashClient(boolean flashClient)

  Sets whether the connected client is a flash client. Flash clients need to receive a special character (i.e. \0) at the end of each xml packet. Flash clients may send the character \0 in incoming packets and may start a connection using another openning tag such as: "flash:client".

  Parameters:
    `flashClient` - true if the if the connection is a flash client.

### getMajorXMPPVersion

    int getMajorXMPPVersion()

  Returns the major version of XMPP being used by this connection (major_version.minor_version. In most cases, the version should be "1.0". However, older clients using the "Jabber" protocol do not set a version. In that case, the version is "0.0".

  Returns:
    the major XMPP version being used by this connection.

### getMinorXMPPVersion

    int getMinorXMPPVersion()

  Returns the minor version of XMPP being used by this connection (major_version.minor_version. In most cases, the version should be "1.0". However, older clients using the "Jabber" protocol do not set a version. In that case, the version is "0.0".

  Returns:
    the minor XMPP version being used by this connection.

### setXMPPVersion

    void setXMPPVersion(int majorVersion,
                        int minorVersion)

  Sets the XMPP version information. In most cases, the version should be "1.0". However, older clients using the "Jabber" protocol do not set a version. In that case, the version is "0.0".

  Parameters:
    `majorVersion` - the major version.
    `minorVersion` - the minor version.

### getLanguage

    String getLanguage()

  Returns the language code that should be used for this connection (e.g. "en").

  Returns:
    the language code for the connection.

### setLanaguage

    void setLanaguage(String language)

  Sets the language code that should be used for this connection (e.g. "en").

  Parameters:
    `language` - the language code.

### isCompressed

    boolean isCompressed()

  Returns true if the connection is using compression.

  Returns:
    true if the connection is using compression.

### getCompressionPolicy

    Connection.CompressionPolicy getCompressionPolicy()

  Returns whether compression is optional or is disabled.

  Returns:
    whether compression is optional or is disabled.

### setCompressionPolicy

    void setCompressionPolicy(Connection.CompressionPolicy compressionPolicy)

  Sets whether compression is enabled or is disabled.

  Parameters:
    `compressionPolicy` - whether Compression is enabled or is disabled.

### getTlsPolicy

    Connection.TLSPolicy getTlsPolicy()

  Returns whether TLS is mandatory, optional or is disabled. When TLS is mandatory clients are required to secure their connections or otherwise their connections will be closed. On the other hand, when TLS is disabled clients are not allowed to secure their connections using TLS. Their connections will be closed if they try to secure the connection. in this last case.

  Returns:
    whether TLS is mandatory, optional or is disabled.

### setTlsPolicy

    void setTlsPolicy(Connection.TLSPolicy tlsPolicy)

  Sets whether TLS is mandatory, optional or is disabled. When TLS is mandatory clients are required to secure their connections or otherwise their connections will be closed. On the other hand, when TLS is disabled clients are not allowed to secure their connections using TLS. Their connections will be closed if they try to secure the connection. in this last case.

  Parameters:
    `tlsPolicy` - whether TLS is mandatory, optional or is disabled.

### getPacketDeliverer

    PacketDeliverer getPacketDeliverer()

  Returns the packet deliverer to use when delivering a packet over the socket fails. The packet deliverer will retry to send the packet using some other connection, will store the packet offline for later retrieval or will just drop it.

  Returns:
    the packet deliverer to use when delivering a packet over the socket fails.

### startTLS

    void startTLS(boolean clientMode,
                  String remoteServer,
                  Connection.ClientAuth authentication)
                  throws Exception

  Secures the plain connection by negotiating TLS with the other peer. In a server-2-server connection the server requesting the TLS negotiation will be the client and the other server will be the server during the TLS negotiation. Therefore, the server requesting the TLS negotiation must pass `true` in the `clientMode` parameter and the server receiving the TLS request must pass `false` in the `clientMode` parameter. Both servers should specify the xmpp domain of the other server in the `remoteServer` parameter.

  In the case of client-2-server the XMPP server must pass `false` in the `clientMode` parameter since it will behave as the server in the TLS negotiation. The `remoteServer` parameter will always be `null`.

  Parameters:
    `clientMode` - boolean indicating if this entity is a client or a server in the TLS negotiation.
    `remoteServer` - xmpp domain of the remote server or `null`. When null a `ClientTrustManager` will be used for verifying certificates otherwise a `ServerTrustManager` will be used.
    `authentication` - policy to use for authenticating the remote peer.
  Throws:
    `Exception` - if an error occured while securing the connection.

### addCompression

    void addCompression()

  Adds the compression filter to the connection but only filter incoming traffic. Do not filter outgoing traffic since we still need to send an uncompressed stanza to the client indicating that he can start compressing the traffic. After we sent the uncompresses stanza we can start compression outgoing traffic as well.

### startCompression

    void startCompression()

  Start compressing outgoing traffic for this connection. Compression will only be available after TLS has been negotiated. This means that a connection can never be using compression before TLS. However, it is possible to use compression without TLS.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.8.2 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2008 Jive Software.